package com.safeluck.aaej.app

import org.springframework.context.annotation.Bean
import org.springframework.context.annotation.ComponentScan
import org.springframework.context.annotation.Configuration
import org.springframework.context.annotation.PropertySource
import org.springframework.web.servlet.config.annotation.EnableWebMvc
import springfox.documentation.builders.ApiInfoBuilder
import springfox.documentation.service.ApiInfo
import springfox.documentation.builders.PathSelectors
import springfox.documentation.builders.RequestHandlerSelectors
import springfox.documentation.spi.DocumentationType
import springfox.documentation.spring.web.plugins.Docket
import springfox.documentation.swagger2.annotations.EnableSwagger2
import javax.persistence.PersistenceProperty


@EnableWebMvc //NOTE: Only needed in a non-springboot application
@EnableSwagger2
@Configuration
@ComponentScan("com.safeluck.aaej.app.controller")
@PropertySource("classpath:swagger.properties")
class SwaggerConfig {
     @Bean
    fun api(): Docket {
        return Docket(DocumentationType.SWAGGER_2)
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.safeluck.aaej.app.controller"))
                .paths(PathSelectors.any())
                .build()
    }


    private fun apiInfo(): ApiInfo {
        return ApiInfoBuilder()
                .title("接口列表 v1.1.0") // 任意，请稍微规范点
                .description("aaej 2019") // 任意，请稍微规范点
                .termsOfServiceUrl("http://localhost:8001/swagger-ui.html") // 将“url”换成自己的ip:port
                .contact("admin") // 无所谓（这里是作者的别称）
                .version("1.1.0")
                .build()
    }

}